#!/usr/bin/python

import os, inspect
""" A program to search and display movie listings """

sourceListings =  [] #This will be a list of lists!

with open(os.path.dirname(inspect.getfile(inspect.currentframe())) + '/movie_data.csv') as fileHandle:
	for line in fileHandle:
		#print line.split(',')
		row = line.split(',')
		if row[0] != 'day': #check to make sure it's not a header row
			sourceListings.append(row)
def titleSearch(listings):
	title = 'relist'
	while title != '':
		if title == 'relist':
			print 'The movies showing at our locations are:'
			for title in uniqueTitles(sourceListings):
				print '\t' + title
		elif title == '':
			print 'Exiting'
		else:
			for row in listings:
				if (row[3].lower().find(title.lower()) > -1):
					printListing(row)
		title = raw_input('Please type the name of your title\nType "relist" to see list of movies again\n(ENTER to quit): ').strip()
def timeSearch(listings):
		early = '0'
		late = '0'
		while early != '' or late != '':
			early = raw_input('Please type the earliest time you can attend a film (in 24-hour format): ')
			late = raw_input('Please type the latest time you can attend a film (in 24-hour format): ')
			if not(early == '') and not(late == ''):
				if late < early:
					print "The later time must be higher than the early time."
					early = '0'
					late = '0'
				else:
					for row in listings:
						showTimes = row[1].split(':')
						for show in showTimes:
							if (int(early) <= int(show) and int(late)
							>= int(show)):
								printListing(row)
								break
def uniqueTitles(listings):
	results = []
	for movie in listings: 
		results.append(movie[3])
	results = list(set(results))
	results.sort()
	return results
def printListing(listing):
	showTimes = listing[1].split(':')
	print listing[3], 'at the', listing[2], 'location is rated',
	print listing[4], 'and runs', listing[5], 'minutes.'
	print len(showTimes), 'showing(s) on', listing[0], 'at',
	timesReport = []
	for showTime in showTimes:
		hr = showTime[0:2]
		mn = showTime[-2:]
		if int(hr) > 12:
			hr = str(int(hr) - 12)
			mn = mn + 'p'
		elif int(hr) == 0: hr = '12'
		timesReport.append(hr + ':' + mn)
	print ','.join(timesReport)
	print '--'*40
if __name__ == '__main__':
	"""
	This is the starting point for the execution of the program.
	"""
	choice = 0
	while choice != '':
		choice = raw_input('Type 1 for Title Search\nType 2 for Time Search\nENTER to quit: ')
		if (choice == '1'):
			titleSearch(sourceListings)
		elif (choice == '2'):
			timeSearch(sourceListings)